% ALLEEG -- [structure] contains 2 epoched datasets to compare
% plots -- [string] 'erp','ersp' or 'erpersp'
% comps -- [list of component indices to plot for ERSP]

function CompareConditions(ALLEEG,plots,plotcomps);

% Define defaults in [] used for either input variables
if isempty(plots)
    plots = 'erpersp'; % default is to plot both
end;
if isempty(plotcomps)
    plotcomps = [1:5]; % default = plot first 5 ICs
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all % clear all past figures

if strcmp(plots(1:3),'erp') % plot ERP comparison
    pop_comperp( ALLEEG, 1, [1 2] ,[], 'addavg', 'off', 'addstd', 'off', 'addall', 'on', 'diffavg', 'off', 'diffstd', 'off', 'tplotopt',{ 'ydir',1, 'limits',[-50 500 0 0]});
    pop_comperp( ALLEEG, 0, [1 2] ,[], 'addavg', 'off', 'addstd', 'off', 'addall', 'on', 'diffavg', 'off', 'diffstd', 'off', 'chans',plotcomps , 'tplotopt',{ 'ydir',1, 'limits',[-50 500 0 0]});    
end;

if strcmp(plots(end-3:end),'ersp') % plot ERSP comparison
    CURRENTSET = 1;
    EEG = ALLEEG(CURRENTSET);
    for ic = 1:length(plotcomps)
        [ALLEEG EEG CURRENTSET] = pop_newset(ALLEEG, EEG, CURRENTSET, 'retrieve',1, 'study',0);
        figure; pop_newtimef( EEG, 0, plotcomps(ic), [-1000  1996], [3         0.5] , 'topovec', EEG.icawinv(:,plotcomps(ic)), 'elocs', EEG.chanlocs, 'chaninfo', EEG.chaninfo, 'baseline',[0], 'alpha',.01,'title',EEG.setname, 'freqs', [3 30], 'plotphase', 'off', 'padratio', 2);
        [ALLEEG EEG CURRENTSET] = pop_newset(ALLEEG, EEG, 1, 'retrieve',2, 'study',0);
        figure; pop_newtimef( EEG, 0, plotcomps(ic), [-1000  1996], [3         0.5] , 'topovec', EEG.icawinv(:,plotcomps(ic)), 'elocs', EEG.chanlocs, 'chaninfo', EEG.chaninfo, 'baseline',[0], 'alpha',.01,'title',EEG.setname, 'freqs', [3 30], 'plotphase', 'off', 'padratio', 2);
    end;
end;

eeglab redraw % redraw EEGLAB because we closed it above
