% This page corresponds to Basic Scripting with Julie Onton
% Below are 3 sequential exercises that build on each other.
% Start with the first, then proceed to the next when you are ready.
% Try writing the assigned scripts yourself, only using the scripts below
% to help if you get stuck. 
% If you do need to use the scripts below, proceed line-by-line in your 
% chosen section and be sure you understand what each line does before
% pasting it into the Matlab window. 
%
% Example scripts and functions produced here can be found in 
% ...\Scripts\ExampleMfiles\
addpath('C:\Users\julie\Documents\Workshops\Finland\Scripts\ExampleMfiles\')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FIRST   Make a script: epochmydata.m 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FROM THE GUI:
% 1) Set memory options to allow more than one dataset in memory at once
% 2) load stern.set
% 3) epoch on all ignore letters (g?),[-1 2], baseline: [-200 0]
% 4) store ignore letters as dataset #2, name appropriately
% 5) return to continuous dataset (#1)
% 6) epoch on all memorize letters
% 7) overwrite continuous dataset and save memorize letters as #1
% At the end, you should have 2 epoched datasets, memorize(1) and ignore(2)
% letters.
% type 'eegh' at the commandline

% now copy and paste the commandline output to a new Matlabe script
% save the script as 'epochmydata.m' in your Matlab directory

% Now try it out:
% clear your datasets, and close EEGLAB
% now run your script by copying and pasting the name of the script:
clear all % clear all variables
close all % close all windows and EEGLAB
epochmydata
% the GUI needs to be refreshed in order so see commands executed via the commandline
eeglab redraw 

%%%% Resulting script should look something like:-----------------
% [ALLEEG EEG CURRENTSET ALLCOM] = eeglab;
% pop_editoptions( 'option_storedisk', 0, 'option_savetwofiles', 1, 'option_saveica', 0, 'option_single', 1, 'option_memmapdata', 0, 'option_computeica', 1, 'option_scaleicarms', 1, 'option_rememberfolder', 1);
% EEG = pop_loadset( 'filename', 'stern.set', 'filepath', 'C:\\Documents and Settings\\eeglab\\My Documents\\MATLAB\\EEGLAB_Workshop\\Data\\');
% [ALLEEG, EEG, CURRENTSET] = eeg_store( ALLEEG, EEG, 0 );
% EEG = pop_epoch( EEG, {  'gB'  'gC'  'gD'  'gF'  'gG'  'gH'  'gJ'  'gK'  'gL'  'gM'  'gN'  'gP'  'gQ'  'gR'  'gS'  'gT'  'gV'  'gW'  'gX'  'gY'  'gZ'  }, [-1  2], 'newname', 'Sternberg: Ignore letters', 'epochinfo', 'yes');
% [ALLEEG EEG CURRENTSET] = pop_newset(ALLEEG, EEG, 1, 'gui', 'off'); 
% EEG = pop_rmbase( EEG, [-200    0]);
% [ALLEEG EEG] = eeg_store(ALLEEG, EEG, CURRENTSET);
% [ALLEEG EEG CURRENTSET] = pop_newset(ALLEEG, EEG, 2, 'retrieve',1, 'study',0); 
% [EEG ALLEEG CURRENTSET] = eeg_retrieve(ALLEEG,1);
% EEG = pop_epoch( EEG, {  'B'  'C'  'D'  'F'  'G'  'H'  'J'  'K'  'L'  'M'  'N'  'P'  'Q'  'R'  'S'  'T'  'V'  'W'  'X'  'Y'  'Z'  }, [-1  2], 'newname', 'Sternberg: Memorize letters', 'epochinfo', 'yes');
% [ALLEEG EEG CURRENTSET] = pop_newset(ALLEEG, EEG, 1, 'overwrite', 'on', 'gui', 'off'); 
% EEG = pop_rmbase( EEG, [-200    0]);
% [ALLEEG EEG] = eeg_store(ALLEEG, EEG, CURRENTSET);
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% paramaterize your epoch script:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% you can replace the absolute paths in your 'epochmydata.m' with 
% the following script for easy access to variables and therefore 
% easy to change...
% Variables-------------------------------
dataset = 'stern.set';
% set datapath to the correct directory for the workshop:
datapath = 'C:\Users\julie\Documents\Workshops\Finland\data';
memepochletts = {'B'  'C'  'D'  'F'  'G'  'H'  'J'  'K'  'L'  'M'  'N'  'P'  'Q'  'R'  'S'  'T'  'V'  'W'  'X'  'Y'  'Z'};
ignepochletts = {'gB'  'gC'  'gD'  'gF'  'gG'  'gH'  'gJ'  'gK'  'gL'  'gM'  'gN'  'gP'  'gQ'  'gR'  'gS'  'gT'  'gV'  'gW'  'gX'  'gY'  'gZ'};
datsetname = {'Sternberg: Ignore letters','Sternberg: Memorize letters'};

[ALLEEG EEG CURRENTSET ALLCOM] = eeglab;
pop_editoptions( 'option_storedisk', 0, 'option_savetwofiles', 1, 'option_saveica', 0, 'option_single', 1, 'option_memmapdata', 0, 'option_computeica', 1, 'option_scaleicarms', 1, 'option_rememberfolder', 1);
EEG = pop_loadset( 'filename', dataset, 'filepath', datapath);
[ALLEEG, EEG, CURRENTSET] = eeg_store( ALLEEG, EEG, 0 );
EEG = pop_epoch( EEG,  ignepochletts  , [-1  2], 'newname',datsetname{1} , 'epochinfo', 'yes');
[ALLEEG EEG CURRENTSET] = pop_newset(ALLEEG, EEG, 1, 'gui', 'off','setname','Ignore letters'); 
EEG = pop_rmbase( EEG, [-200    0]);
[ALLEEG EEG] = eeg_store(ALLEEG, EEG, CURRENTSET);
[ALLEEG EEG CURRENTSET] = pop_newset(ALLEEG, EEG, 2, 'retrieve',1, 'study',0); 
[EEG ALLEEG CURRENTSET] = eeg_retrieve(ALLEEG,1);
EEG = pop_epoch( EEG, memepochletts, [-1  2], 'newname',datsetname{2}, 'epochinfo', 'yes');
[ALLEEG EEG CURRENTSET] = pop_newset(ALLEEG, EEG, 1, 'overwrite', 'on','setname',datsetname{2}, 'gui', 'off'); 
EEG = pop_rmbase( EEG, [-200    0]);
[ALLEEG EEG] = eeg_store(ALLEEG, EEG, CURRENTSET);
eeglab redraw

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SECOND script  artifactrejection.m    ****
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% from the GUI:
% 1) Run 'epochmydata.m' to have 2 epoched datasets active
% 2) Go to dataset #1 (Memorize letters)
% 3) From Tools menu, go to 'Automatic epoch rejection' 
% 4) Uncheck the option to view results
% 5) Set thresholds, probability and % rejection limits (defaults are fine)
% 6) Allow time for this to process
% 7) Now switch to Ignore letter dataset (#2)
% 8) Run the same auto rejection protocol as above
% 9) type >> eegh
% 10) Make sure the first line is a dataset retrieval for dataset #1
%  * if it is not, copy and paste the 'pop_newset' line in the history to 
%    the first line and adapt to load dataset #1 instead of #2
% 11) Save this new script as 'artifactrejection.m' in your Matlab path
        
% Now try running both scripts:
clear all % clear all variables
close all % close all windows and EEGLAB
epochmydata
artifactrejection
eeglab redraw;  % update gui with new dataset information
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% THIRD   Make:  plotfigs.m    ****
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1) run 'epochmydata' and 'artifactrejection'
% 2) Switch to dataset #1, Memorize letters
% 2) from the GUI, go to Plot -> Sum/Compare ERPs
% 3) input '1,3' as Datasets to average
% 4) check 'allERPs', uncheck 'avg' boxes
% 5) low pass as desired (ie, 20 Hz)
% 6) set ydir to the reasonable +=up (1)
% 7) add 'limits',[-100 600 0 0] to the additional commandline
% 8) try the same parameters, but choose one or more components in:
%    Plot->Sum/Compare comp. ERPs
% 8) now go to Plot->Time-frequency transforms
% 9) input freq limits to [3 30] (or as desired), increase padratio to 2
% 10) input bootstrap threshold to .01
% 11) inpute appropriate title in the optional inputs: 'title','Ignore
% letters'
% 11) swith to dataset #2 and repeat
% 11) type eegh
% 12) copy the pop_newtimef and retrieval commands to a new script called
%     plotfigs.m in your Matlab directory
% Are there any ERP/ERSP differences between conditions?

% Now try creating a loop in your 'plotfigs.m' script that will cycle 
% through a desired list of ICs below is an example, but try writing 
% it yourself first
close all
plotcomps = [2:6];
for ic = 1:length(plotcomps)
    [ALLEEG EEG CURRENTSET] = pop_newset(ALLEEG, EEG, CURRENTSET, 'retrieve',1, 'study',0);
    figure; pop_newtimef( EEG, 0, plotcomps(ic), [-1000  1996], [3         0.5] , 'topovec', EEG.icawinv(:,plotcomps(ic)), 'elocs', EEG.chanlocs, 'chaninfo', EEG.chaninfo, 'baseline',[0], 'alpha',.01,'title','Memorize letters', 'freqs', [3 30], 'plotphase', 'off', 'padratio', 2);
    [ALLEEG EEG CURRENTSET] = pop_newset(ALLEEG, EEG, 1, 'retrieve',2, 'study',0);
    figure; pop_newtimef( EEG, 0, plotcomps(ic), [-1000  1996], [3         0.5] , 'topovec', EEG.icawinv(:,plotcomps(ic)), 'elocs', EEG.chanlocs, 'chaninfo', EEG.chaninfo, 'baseline',[0], 'alpha',.01,'title','Ignore letters', 'freqs', [3 30], 'plotphase', 'off', 'padratio', 2);
end;
eeglab redraw
% Note that I added a switch to dataset #1 from 'CURRENTSET' which will 
% input the index of the current EEG dataset to switch FROM
% the call to IC 1 with the variable 'plotcomps(ic)' which is my looping
% variable
% Do you see any ERSP differences between Memorize and Ignore conditions?
% Perhaps try a different set of components?

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ADVANCED: create a parameterized function from 'plotfigs.m'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 'functions', as opposed to scripts, take arguments and can return
% variables. Their variables are local and do not draw from the global
% workspace and must therefore be provided as inputs
% for example, a useful function from the plotfigs script might be:
plots = 'erpersp';
plotcomps = [2:4];
CompareConditions(ALLEEG,plots,plotcomps);

% functions are convenient if you have a common routine for which you 
% only need to change certain parameters with each iteration

% Now you could run a whole series of steps with just a few lines:

clear all % clear all variables
close all % close all windows and EEGLAB
epochmydata
artifactrejection
% define parameters:
plots = 'erpersp'; % easily toggle which measures to plot
plotcomps = [2:4]; % easily adjust ICs to plot
CompareConditions(ALLEEG,plots,plotcomps);

